package corel.webdata;

class ChartRange {
   protected static int[] anNiceDivs = new int[]{1, 10, 2, 5, 3, 4, 20, 25, 50, 100};
   protected static final int NICEDIVSLEN;
   protected static final int MIN_DIVS = 3;
   protected static final int MAX_DIVS = 10;
   protected static int[] rnSearch;
   protected static final int SEARCHLEN;

   static void MinMaxFixedRange(AxisLook var0, float var1, float var2, boolean var3) {
      float var4 = var2 - var1;
      float var9 = (float)(Math.log((double)var4) * 0.4342944819033001);
      double var21 = (double)var9;
      var21 = (double)(var9 - (float)((int)(var21 >= (double)0.0F ? var21 + (double)0.5F : var21 - (double)0.5F)));
      float var6;
      if (!(Math.abs(var21 - (double)0.0F) <= 1.0E-14) && true) {
         var6 = (float)Math.pow((double)10.0F, Math.floor((double)var9) - (double)1.0F);
      } else {
         var6 = (float)Math.pow((double)10.0F, (double)var9 - (double)2.0F);
      }

      var21 = (double)(var4 / var6);
      int var8 = (int)(var21 >= (double)0.0F ? var21 + (double)0.5F : var21 - (double)0.5F);
      boolean var11 = false;
      int var12 = 0;
      var21 = (double)((float)var8 * var6);
      double var23 = (double)var4;
      if (Math.abs(var21 - var23) <= 1.0E-14 || false) {
         for(var12 = 0; var12 < NICEDIVSLEN && !var11; ++var12) {
            var21 = (double)((float)var8 / (float)anNiceDivs[var12]);
            int var13 = (int)(var21 >= (double)0.0F ? var21 + (double)0.5F : var21 - (double)0.5F);
            if (var13 >= 3 && var13 <= 10) {
               var11 = var8 % anNiceDivs[var12] == 0;
            }
         }
      }

      int var5;
      if (var11) {
         var5 = anNiceDivs[var12 - 1];
      } else {
         if (var8 >= 9 && var8 <= 16) {
            var5 = 2;
         } else if (var8 >= 17 && var8 <= 29) {
            var5 = 4;
         } else if (var8 >= 30 && var8 <= 44) {
            var5 = 5;
         } else if (var8 >= 45 && var8 <= 79) {
            var5 = 10;
         } else if (var8 >= 80 && var8 <= 100) {
            var5 = 20;
         } else {
            var5 = 1;
         }

         if (var3) {
            var5 *= 2;
         }
      }

      float var7 = (float)((double)var5) * var6;
      float var10 = var4 / var7;
      var21 = (double)var10;
      var21 = (double)((int)(var21 >= (double)0.0F ? var21 + (double)0.5F : var21 - (double)0.5F));
      var23 = (double)var10;
      if (!(Math.abs(var21 - var23) <= 1.0E-14) && true) {
         float var14;
         float var15;
         float var19;
         float var20;
         boolean var10000;
         label239: {
            var21 = (double)var1;
            var23 = (double)var7;
            var19 = (float)(Math.ceil(var21 / var23) * var23);
            var21 = (double)var2;
            var23 = (double)var7;
            var20 = (float)(Math.floor(var21 / var23) * var23);
            var14 = (var19 - var1) / var7;
            var15 = (var2 - var20) / var7;
            var21 = (double)var14;
            if (var21 - (double)0.0F > 1.0E-14 || false) {
               var21 = (double)var14;
               if (var21 - (double)0.25F < -1.0E-14 || false) {
                  var10000 = true;
                  break label239;
               }
            }

            var10000 = false;
         }

         boolean var16;
         label240: {
            var16 = var10000;
            var21 = (double)var15;
            if (var21 - (double)0.0F > 1.0E-14 || false) {
               var21 = (double)var15;
               if (var21 - (double)0.25F < -1.0E-14 || false) {
                  var10000 = true;
                  break label240;
               }
            }

            var10000 = false;
         }

         boolean var17 = var10000;
         if (var16 || var17) {
            float var18;
            if ((double)(var14 + var15) > (double)0.25F) {
               var18 = (float)((double)var7 * (double)0.25F);
            } else {
               var18 = (float)((double)var7 * (double)0.5F);
            }

            var21 = (double)(var18 + var19 - var1);
            var23 = (double)var7;
            if (!(var21 - var23 > 1.0E-14) && true) {
               var19 += var18;
               var21 = (double)(var18 + var20);
               var23 = (double)var2;
               if (!(var21 - var23 < -1.0E-14) && true) {
                  var20 -= var7 - var18;
               } else {
                  var20 += var18;
               }
            } else {
               var19 -= var18;
               var21 = (double)(var18 + var2 - var20);
               var23 = (double)var7;
               if (!(var21 - var23 > 1.0E-14) && true) {
                  var20 -= var18;
               } else {
                  var20 += var7 - var18;
               }
            }
         }

         var0.fDivSize = var7;
         var0.bOddDivs = true;
         var0.nMajorHash = 0;
         var21 = (double)var19;
         var23 = (double)var1;
         if (!(Math.abs(var21 - var23) <= 1.0E-14) && true) {
            var0.fMinEndOff = var19 - var1;
            ++var0.nMajorHash;
         } else {
            var0.fMinEndOff = 0.0F;
         }

         var21 = (double)var20;
         var23 = (double)var2;
         if (!(Math.abs(var21 - var23) <= 1.0E-14) && true) {
            var0.fMaxEndOff = var2 - var20;
            ++var0.nMajorHash;
         } else {
            var0.fMaxEndOff = 0.0F;
         }

         var21 = (double)((var4 - var0.fMinEndOff - var0.fMaxEndOff) / var7);
         var0.nMajorHash += (int)(var21 >= (double)0.0F ? var21 + (double)0.5F : var21 - (double)0.5F) - 1;
      } else {
         var0.fMinEndOff = var7;
         var0.fMaxEndOff = var7;
         var21 = (double)var10;
         var0.nMajorHash = (int)(var21 >= (double)0.0F ? var21 + (double)0.5F : var21 - (double)0.5F) - 1;
         var0.fDivSize = var7;
         var0.bOddDivs = false;
      }

      var0.fMin = (double)var1;
      var0.fMax = (double)var2;
   }

   static void MinMax(AxisLook var0, float var1, float var2, boolean var3) {
      float var4 = var2 - var1;
      float var12 = (float)(Math.log((double)var4) * 0.4342944819033001);
      double var13 = (double)var12;
      var13 = (double)(var12 - (float)((int)(var13 >= (double)0.0F ? var13 + (double)0.5F : var13 - (double)0.5F)));
      float var7;
      if (!(Math.abs(var13 - (double)0.0F) <= 1.0E-14) && true) {
         var7 = (float)Math.pow((double)10.0F, Math.floor((double)var12) - (double)1.0F);
      } else {
         var7 = (float)Math.pow((double)10.0F, (double)var12 - (double)2.0F);
      }

      int var11 = (int)(var4 / var7) - 1;
      int var5;
      if (var11 >= 9 && var11 <= 16) {
         var5 = 2;
      } else if (var11 >= 17 && var11 <= 29) {
         var5 = 4;
      } else if (var11 >= 30 && var11 <= 44) {
         var5 = 5;
      } else if (var11 >= 45 && var11 <= 79) {
         var5 = 10;
      } else if (var11 >= 80 && var11 <= 99) {
         var5 = 20;
      } else {
         var5 = 1;
      }

      if (var3) {
         var5 *= 2;
      }

      float var8 = (float)((double)var5) * var7;
      float var10 = (float)Math.floor((double)(var1 / var8)) * var8;

      while(true) {
         var13 = (double)var10;
         double var15 = (double)var1;
         if (!(var13 - var15 > 1.0E-14) && true) {
            float var9 = var10;
            int var6 = 0;

            while(true) {
               var13 = (double)var9;
               var15 = (double)var2;
               if (!(var13 - var15 < -1.0E-14) && true) {
                  var0.fMin = (double)var10;
                  var0.fMax = (double)var9;
                  var0.nMajorHash = var6 - 1;
                  var0.fDivSize = var8;
                  var0.bOddDivs = false;
                  return;
               }

               ++var6;
               var9 += var8;
            }
         }

         var10 -= var8;
      }
   }

   static double log10(float var0) {
      return Math.log((double)var0) * 0.4342944819033001;
   }

   static double CEILMULTIPLE(double var0, double var2) {
      return Math.ceil(var0 / var2) * var2;
   }

   static double FLOORMULTIPLE(double var0, double var2) {
      return Math.floor(var0 / var2) * var2;
   }

   static boolean FLOATEQUAL(double var0, double var2) {
      return Math.abs(var0 - var2) <= 1.0E-14;
   }

   static boolean FLOATLESSTHAN(double var0, double var2) {
      return var0 - var2 < -1.0E-14;
   }

   static boolean FLOATGREATERTHAN(double var0, double var2) {
      return var0 - var2 > 1.0E-14;
   }

   static int ROUND(double var0) {
      return (int)(var0 >= (double)0.0F ? var0 + (double)0.5F : var0 - (double)0.5F);
   }

   static {
      NICEDIVSLEN = anNiceDivs.length;
      rnSearch = new int[]{1, 2, 4, 5, 10, 20, 25, 50, 100};
      SEARCHLEN = rnSearch.length;
   }
}
