import corel.webdata.HARes;
import corel.webdata.View;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Frame;
import java.awt.Window;

public class ViewApplet extends Applet implements Runnable {
   protected View hotView;
   protected boolean isInFrame = false;
   protected static boolean ignoreFrame;

   public void init() {
      ((Container)this).setLayout(new BorderLayout());
      String var3 = ((Applet)this).getParameter(HARes.HA_PARAM_FRAME);
      this.isInFrame = var3 == null ? false : Boolean.valueOf(var3);
      var3 = ((Applet)this).getParameter(HARes.HA_PARAM_WIDTH);

      int var1;
      try {
         var1 = var3 == null ? 500 : Integer.valueOf(var3);
      } catch (Exception var6) {
         var1 = 500;
      }

      var3 = ((Applet)this).getParameter(HARes.HA_PARAM_HEIGHT);

      int var2;
      try {
         var2 = var3 == null ? 300 : Integer.valueOf(var3);
      } catch (Exception var5) {
         var2 = 300;
      }

      this.hotView = new View(this);
      if (this.isInFrame && !ignoreFrame) {
         Frame var4 = new Frame(HARes.HV_APPLET_NAME);
         ((Container)var4).add("Center", this.hotView);
         ((Component)var4).resize(var1, var2);
         ((Window)var4).show();
      } else {
         ((Container)this).add("Center", this.hotView);
      }
   }

   public String[][] getParameterInfo() {
      String[][] var1 = new String[][]{{HARes.HA_PARAM_HORGRID, HARes.PARAM_TYPE_BOOLEAN, HARes.HA_PARAMDESC_HORGRID}, {HARes.HA_PARAM_VERTGRID, HARes.PARAM_TYPE_BOOLEAN, HARes.HA_PARAMDESC_VERTGRID}, {HARes.HA_PARAM_3DGRID, HARes.PARAM_TYPE_BOOLEAN, HARes.HA_PARAMDESC_3DGRID}, {HARes.HV_PARAM_ROWHEADER, HARes.PARAM_TYPE_BOOLEAN, HARes.HV_PARAMDESC_ROWHEADER}, {HARes.HV_PARAM_SORT, HARes.PARAM_TYPE_BOOLEAN, HARes.HV_PARAMDESC_SORT}, {HARes.HA_PARAM_FRAME, HARes.PARAM_TYPE_BOOLEAN, HARes.HA_PARAMDESC_FRAME}, {HARes.HA_PARAM_WIDTH, HARes.PARAM_TYPE_INT, HARes.HA_PARAMDESC_WIDTH}, {HARes.HA_PARAM_HEIGHT, HARes.PARAM_TYPE_INT, HARes.HA_PARAMDESC_HEIGHT}, {HARes.HV_PARAM_SELECT, HARes.PARAM_TYPE_BOOLEAN, HARes.HV_PARAMDESC_SELECT}, {HARes.HA_PARAM_NUMBEROFCOLUMNS, HARes.PARAM_TYPE_INT, HARes.HA_PARAMDESC_NUMBEROFCOLUMNS}, {HARes.HA_PARAM_COL_, HARes.PARAM_TYPE_STRING, HARes.HA_PARAMDESC_COL_}, {HARes.HV_PARAM_TYPE_C_, HARes.PARAM_TYPE_INT, HARes.HV_PARAMDESC_TYPE_C_}, {HARes.HV_PARAM_LEN_C_, HARes.PARAM_TYPE_INT, HARes.HV_PARAMDESC_LEN_C_}, {HARes.HV_PARAM_FIELDDELIM, HARes.PARAM_TYPE_STRING, HARes.HV_PARAMDESC_FIELDDELIM}, {HARes.HV_PARAM_RECORDDELIM, HARes.PARAM_TYPE_STRING, HARes.HV_PARAMDESC_RECORDDELIM}, {HARes.HV_PARAM_MEMOLINEDELIM, HARes.PARAM_TYPE_STRING, HARes.HV_PARAMDESC_MEMOLINEDELIM}, {HARes.HA_PARAM_DATA, HARes.PARAM_TYPE_STRING, HARes.HA_PARAMDESC_DATA}};
      return var1;
   }

   public String getAppletInfo() {
      return HARes.HV_APPLET_INFO;
   }

   public void start() {
   }

   public void run() {
   }

   public void stop() {
   }

   public void destroy() {
   }
}
