package corel.webdata;

import java.awt.Component;
import java.util.Hashtable;

public class AnalyzerOption implements AnalyzerControl {
   protected String myText;
   protected boolean initState = false;
   public String myValue;
   protected int nextFlowState;

   public AnalyzerOption(String var1) {
      this.myText = var1.trim();
   }

   public void translateAttributes(Hashtable var1) {
      this.initState = AttrConverter.getBool(var1, "selected");

      try {
         this.myValue = AttrConverter.getStr(var1, "value");
      } catch (Exception var3) {
         this.myValue = null;
      }

      try {
         this.nextFlowState = AttrConverter.getIntWithException(var1, "nextflowstate");
      } catch (Exception var2) {
         this.nextFlowState = -1;
      }
   }

   public void addAnalyzerControl(AnalyzerControl var1, String var2, Hashtable var3) {
   }

   public String toString() {
      return this.myText;
   }

   public String getName() {
      return this.myText;
   }

   public boolean getInitState() {
      return this.initState;
   }

   public String getValue() {
      return this.myValue == null ? this.myText : this.myValue;
   }

   public String getMyValue() {
      return this.myValue;
   }

   public String getValue(String var1) {
      return this.getValue();
   }

   public boolean setValue(String var1) {
      return false;
   }

   public boolean setValue(String var1, String var2) {
      return this.setValue(var1);
   }

   public boolean isValueValid() {
      return true;
   }

   public void reset(boolean var1) {
   }

   public boolean isContainer() {
      return false;
   }

   public boolean getValues(Hashtable var1) {
      return false;
   }

   public void setFocusOnMe(boolean var1) {
   }

   public void moveFocus(Component var1, boolean var2) {
   }

   public int getFlowOrder() {
      return 0;
   }

   public int getNextFlowState() {
      return this.nextFlowState;
   }

   public void flowStateChanged(int var1, boolean var2, Component var3) {
   }

   public void enableControl(boolean var1) {
   }
}
