package corel.webdata;

public class RangeElement {
   protected int min;
   protected int max;
   protected boolean multi = false;
   protected int counter = 0;

   public void addNumber(int var1) {
      if (this.counter == 0) {
         this.min = var1;
         ++this.counter;
      } else if (this.counter == 1) {
         this.max = var1;
         ++this.counter;
      }

      this.multi = this.counter > 1;
   }

   public boolean check(int var1) {
      if (this.multi) {
         return this.min <= var1 && this.max >= var1;
      } else {
         return this.min == var1;
      }
   }

   public String toString() {
      return "min=" + this.min + " max=" + this.max + " multi=" + this.multi + " counter=" + this.counter;
   }
}
