package corel.webdata;

import java.awt.Graphics;
import java.util.Vector;

public class ViewListOfColumns extends Vector {
   public final int DEFAULT_COLUMN_HEIGHT = 20;
   protected int prevColumnNo;
   protected boolean firstTime = true;

   public synchronized ViewColumn columnAt(int var1) {
      return (ViewColumn)((Vector)this).elementAt(var1);
   }

   public void setPressed(int var1, boolean var2) {
      if (!this.columnAt(var1).isPressed()) {
         if (!this.firstTime) {
            this.columnAt(this.prevColumnNo).setPressed(!this.columnAt(this.prevColumnNo).isPressed());
         } else {
            this.firstTime = !this.firstTime;
         }

         this.columnAt(var1).setPressed(var2);
         this.prevColumnNo = var1;
      }

   }

   public void setState(int var1, boolean var2) {
      this.columnAt(var1).setPressed(var2);
   }

   public int getPrevPressedColumn() {
      return !this.firstTime ? this.prevColumnNo : -1;
   }

   public int getHeaderHeight(Graphics var1) {
      int var2 = 0;

      for(int var3 = 0; var3 < ((Vector)this).size(); ++var3) {
         var2 = Math.max(this.columnAt(var3).getHeight(var1), var2);
      }

      return var2 < 20 ? 20 : var2;
   }
}
