package corel.webdata;

import java.awt.Graphics;
import java.util.Vector;

public class ViewRecord extends Vector {
   protected boolean isMyHeaderSelected = false;

   public synchronized ViewField fieldAt(int var1) {
      return (ViewField)((Vector)this).elementAt(var1);
   }

   public boolean greaterThan(ViewRecord var1, int var2) {
      return this.fieldAt(var2).greaterThan(var1.fieldAt(var2));
   }

   public int getRecordHeight(Graphics var1) {
      int var2 = 0;

      for(int var3 = 0; var3 < ((Vector)this).size(); ++var3) {
         var2 = Math.max(this.fieldAt(var3).getFieldHeight(var1), var2);
      }

      return var2;
   }

   public void selectHeader() {
      this.isMyHeaderSelected = true;
   }

   public void unselectHeader() {
      this.isMyHeaderSelected = false;
   }

   public boolean isHeaderSelected() {
      return this.isMyHeaderSelected;
   }
}
