package corel.webdata;

import java.awt.Rectangle;

final class ViewRecordInfo {
   public int recordNo;
   public int fieldNo;
   public Rectangle fieldRect;
   public boolean isHeaderSelected;
   public int columnNo;
   public boolean isColumnSelected;

   public ViewRecordInfo(int var1, int var2, Rectangle var3, boolean var4) {
      this.recordNo = var1;
      this.fieldNo = var2;
      this.fieldRect = var3;
      this.isHeaderSelected = var4;
      this.isColumnSelected = false;
   }

   public ViewRecordInfo(int var1) {
      this.isHeaderSelected = false;
      this.isColumnSelected = true;
      this.columnNo = var1;
   }
}
