package corel.webdata;

class ViewTokenizer {
   public String data;
   public String delim;
   public int currentPos;
   public int maxPos;

   public ViewTokenizer(String var1, String var2) {
      this.data = var1;
      this.delim = var2;
      this.currentPos = 0;
      this.maxPos = this.data.length();
   }

   public String getNextToken() {
      int var2 = this.currentPos;
      int var3 = this.data.indexOf(this.delim, var2);
      String var1;
      if (var3 >= 0) {
         var1 = this.data.substring(var2, var3);
         this.currentPos = var3;
         this.currentPos += this.delim.length();
      } else {
         var1 = this.data.substring(var2);
         this.currentPos = this.maxPos;
      }

      return var1;
   }

   public boolean hasMoreTokens() {
      return this.currentPos < this.maxPos;
   }

   public int countTokens() {
      int var1 = 0;

      for(int var2 = this.currentPos; var2 < this.maxPos; ++var1) {
         int var3 = this.data.indexOf(this.delim, var2);
         if (var3 >= 0) {
            var2 = var3 + this.delim.length();
         } else {
            var2 = this.maxPos;
         }
      }

      return var1;
   }
}
